import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";

var reqAnimFrame = requestAnimationFrame || function (fn) {
  return setTimeout(fn, 1000 / 60);
};

var AnimationFrame = function AnimationFrame() {
  var _this = this;

  _classCallCheck(this, AnimationFrame);

  this.counter = 0;

  this.incCounter = function () {
    _this.counter += 1;
    _this.id = reqAnimFrame(_this.incCounter);
  };

  this.stop = function () {
    if (requestAnimationFrame) {
      cancelAnimationFrame(_this.id);
    } else {
      clearTimeout(_this.id);
    }
  };

  this.throttle = function (fn) {
    var lastCall = _this.counter;
    return function (e) {
      if (_this.counter !== lastCall) {
        fn(e);
        lastCall = _this.counter;
      }
    };
  };

  this.incCounter();
};

export { AnimationFrame as default };