import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React, { useEffect, memo, useRef } from "react";
import { COL } from "../reducer/constants";
export var DividerTouch = memo(function (props) {
  var renders = useRef(0);
  renders.current++;
  var actions = props.actions,
      divider = props.divider,
      resizeEl = props.resizeEl;

  function onMouseUp() {
    actions.setDividerDown(undefined);
    removeListeners();
  }

  function removeListeners() {
    document.removeEventListener("mouseup", onMouseUp);
  }

  function onMouseDown(_ref) {
    var clientX = _ref.clientX,
        clientY = _ref.clientY;
    var rect = resizeEl.current.getBoundingClientRect();
    actions.setDividerDown(_objectSpread({}, divider, {
      startX: clientX - rect.x,
      startY: clientY - rect.y
    }));
    document.addEventListener("mouseup", onMouseUp);
  }

  useEffect(function () {
    return removeListeners;
  }, ["once"]);
  var styles = dividerStyle(props);
  return React.createElement("div", {
    style: styles.touch,
    onMouseDown: onMouseDown,
    className: "divider"
  }, React.createElement("div", {
    style: styles.border
  }, renders.current && false, React.createElement("div", {
    style: styles.inner
  })));
}, function (old, props) {
  return old.divider.width === props.divider.width && old.divider.height === props.divider.height && old.divider.top === props.divider.top && old.divider.direction === props.divider.direction && old.divider.left === props.divider.left && old.subdivide.touchMargin === props.subdivide.touchMargin;
});

function dividerStyle(props) {
  var _props$divider = props.divider,
      width = _props$divider.width,
      height = _props$divider.height,
      top = _props$divider.top,
      left = _props$divider.left,
      direction = _props$divider.direction;
  var touchMargin = props.subdivide.touchMargin;
  var touch = {
    width: width,
    height: height,
    top: top,
    left: left,
    //     backgroundColor: 'rgba(0,0,0,0.5)',
    position: "absolute"
  };

  if (direction === COL) {
    touch.cursor = "row-resize";
    touch.top -= touchMargin;
    touch.height += touchMargin * 2;
  } else {
    touch.cursor = "col-resize";
    touch.left -= touchMargin;
    touch.width += touchMargin * 2;
  }

  return {
    touch: touch
  };
}