import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React from "react";
import { COL } from "../reducer/constants";
import { DividerTouch } from "./DividerTouch";
import { useSubdivide } from "./useSubdivide";

function Rect(props) {
  var style = props.style;
  var _props$style = props.style,
      left = _props$style.left,
      top = _props$style.top;
  style = _objectSpread({}, {}, style, {
    transform: "translate3d(".concat(left, "px,").concat(top, "px,0)"),
    position: "absolute",
    top: 0,
    left: 0
  });
  return React.createElement("div", Object.assign({}, props, {
    style: style
  }));
}

export function Dividers(props) {
  var _useSubdivide = useSubdivide(),
      _useSubdivide$state = _useSubdivide.state,
      borderColor = _useSubdivide$state.borderColor,
      cellSpaceColor = _useSubdivide$state.cellSpaceColor;

  var dividers = props.dividers,
      subdivide = props.subdivide,
      actions = props.actions,
      resizeEl = props.resizeEl;
  var borderSize = subdivide.borderSize; //let touch = dividers.map(touch).toSeq()

  function toBorder(divider) {
    var width = divider.width,
        height = divider.height,
        top = divider.top,
        left = divider.left,
        id = divider.id;
    var style = {
      width: width,
      height: height,
      top: top,
      left: left,
      backgroundColor: borderColor
    };
    return React.createElement(Rect, {
      style: style,
      key: "r" + id
    });
  }

  function toInner(divider) {
    var width = divider.width,
        height = divider.height,
        top = divider.top,
        left = divider.left,
        id = divider.id,
        direction = divider.direction;
    var style;

    if (direction === COL) {
      style = {
        width: width + borderSize * 2,
        height: height - borderSize * 2,
        top: top + borderSize,
        left: left - borderSize,
        backgroundColor: cellSpaceColor
      };
    } else {
      style = {
        width: width - borderSize * 2,
        height: height + borderSize * 2,
        top: top - borderSize,
        left: left + borderSize,
        backgroundColor: cellSpaceColor
      };
    }

    if (style.left < 0) {
      style.width = style.width + style.left;
      style.left = 0;
    }

    style.width = Math.min(style.width, subdivide.width - style.left);

    if (style.top < 0) {
      style.height = style.height + style.top;
      style.top = 0;
    }

    style.height = Math.min(style.height, subdivide.height - style.top);
    return React.createElement(Rect, {
      style: style,
      key: "r2" + id
    });
  }

  function toTouch(divider) {
    return React.createElement(DividerTouch, {
      resizeEl: resizeEl,
      divider: divider,
      subdivide: subdivide,
      actions: actions,
      key: divider.id
    });
  }

  var dividerList = Object.values(dividers);
  return React.createElement("div", null, dividerList.map(toBorder), dividerList.map(toInner), dividerList.map(toTouch));
}