import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React from "react";
import { SW, NE, SE, NW } from "../reducer/constants";
export function Triangle(props) {
  function onMouseDown(e) {
    e.preventDefault();
    var actions = props.actions,
        corner = props.corner,
        pane = props.pane; // if (!subdivide.cornerDown) return;

    actions.setCornerDown(_objectSpread({}, pane, {
      corner: corner
    }));
  }

  function onMouseEnter() {
    var actions = props.actions,
        corner = props.corner,
        pane = props.pane;
    actions.setCornerHover({
      paneId: pane.id,
      corner: corner
    });
  }

  function onMouseLeave() {
    var actions = props.actions;
    actions.setCornerHover(undefined);
  }

  var styles = getStyles(props);
  return React.createElement("div", {
    key: "outer",
    style: styles.outer,
    onMouseDown: onMouseDown,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, React.createElement("div", {
    style: styles.inner
  }));
}

function getStyles(props) {
  var corner = props.corner,
      color = props.color,
      size = props.size,
      subdivide = props.subdivide,
      pane = props.pane;
  var cornerHover = subdivide.cornerHover;
  var offset = (size + 3) / 2;
  var outer = {
    width: size,
    height: size,
    position: "absolute",
    backgroundColor: "rgba(0,0,0,0)",
    opacity: 1,
    display: subdivide.dividerDown ? "none" : "block"
  };

  if (corner === NE) {
    outer = _objectSpread({}, outer, {
      top: 0,
      right: 0,
      cursor: "grab",
      transform: "translate3d(".concat(offset, "px, ").concat(-offset, "px, 0) rotate(225deg)")
    });
  } else if (corner === SW) {
    outer = _objectSpread({}, outer, {
      bottom: 0,
      left: 0,
      cursor: "grab",
      transform: "translate3d(".concat(-offset, "px,").concat(offset, "px, 0) rotate(45deg)")
    });
  } else if (corner === SE) {
    outer = _objectSpread({}, outer, {
      bottom: 0,
      right: 0,
      cursor: "grab",
      transform: "translate3d(".concat(offset, "px,").concat(offset, "px, 0) rotate(315deg)")
    });
  } else if (corner === NW) {
    outer = _objectSpread({}, outer, {
      top: 0,
      left: 0,
      cursor: "grab",
      transform: "translate3d(".concat(-offset, "px,").concat(-offset, "px, 0) rotate(135deg)")
    });
  }

  var hover = cornerHover && cornerHover.paneId === pane.id && cornerHover.corner === corner ? 0 : offset;
  var inner = {
    border: "1px solid #c0c0d0",
    backgroundColor: color,
    width: "100%",
    height: "100%",
    transform: "translate3d(0,".concat(hover, "px,0)"),
    transition: "transform .1s"
  };
  return {
    outer: outer,
    inner: inner
  };
}