import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import React, { createContext, useReducer, useContext, useRef } from "react";
import { reducer, createLayout } from "../reducer";
import * as _actions from "../reducer/subdivideActionCreators";
var SubdivideCtx = createContext();

function bindActions(dispatch, actions) {
  var bound = _objectSpread({}, actions);

  var _loop = function _loop(key) {
    var fn = bound[key];

    bound[key] = function () {
      return dispatch(fn.apply(void 0, arguments));
    };
  };

  for (var key in bound) {
    _loop(key);
  }

  return bound;
} // bind them


var selectors = {};
export function useSubdivide() {
  return useContext(SubdivideCtx);
} // children as fn json

export function SubdivideProvider(_ref) {
  var _ref$initialState = _ref.initialState,
      initialState = _ref$initialState === void 0 ? createLayout() : _ref$initialState,
      children = _ref.children;

  var _useReducer = useReducer(reducer, initialState),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  window.dispatch = dispatch;
  var actions = useRef(bindActions(dispatch, _actions));
  return React.createElement(SubdivideCtx.Provider, {
    value: {
      state: state,
      actions: actions.current,
      selectors: selectors
    }
  }, children);
}